#!/usr/bin/perl -w 
use strict;
#
# ====================================================================
#
# Main control panel
#
# Date: 14 Aug 2003
# Author: Jerome Delamarche (c) Copyright INODES.  2003  All rights reserved.
# Version: 2.0
#
# Input Parameters:	
#				stattype
#
# Output: 		display the control panel
#
# --------------------------------------------------------------------
#
# TODO:
#
# ====================================================================
#
use CGI qw/:standard/;

require "dbbenchmark.inc.pl";

my $query = new CGI;
my $gStatType = undef;
if (defined($query)) { $gStatType = $query->param("stattype"); }
if (!defined($gStatType) or $gStatType eq "") { $gStatType = "DATA"; }

my $db = CDBBenchmark->new($Globals::dbtype,$Globals::dbname,
				$Globals::dbserver,$Globals::dbuser,$Globals::dbpwd);
my $layerwidth  = 540;
my $layerheight = 250;
my $graphwidth  = $layerwidth - 60;
my $graphheight = $layerheight - 40;
my $gTitle;
my $gHelp;

# HTML Output start:
print header;
print << "_END_HTML_";
<html>
<head>
	<title>Statistics Main Page</title>
	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
	<link rel="stylesheet" type="text/css" href="../cpanel.css">

<script language="JavaScript">
<!--
function TransformList(opt)
{
	var count = 0;
_END_HTML_

	if (Util::IsBrowserMSIE($query)) {
		print << "_END_HTML_";
		for ( var i = 0 ; i < opt.length ; i++ ) {
			if (opt[i].selected) {
				count++;
				eval('document.all.statform.' + opt[i].value + '.value = "yes";');
			}
			else
				eval('document.all.statform.' + opt[i].value + '.value = "";');
		}
_END_HTML_
	}
	else {
		print << "_END_HTML_";
		for ( var i = 0 ; i < opt.length ; i++ ) {
			if (opt[i].selected) {
				eval('document.statform.' + opt[i].value + '.value = "yes";');
				count++;
			}
			else
				eval('document.statform.' + opt[i].value + '.value = "";');
		}
_END_HTML_
	}
	
	print "return count;\n",
"}\n";

print << "_END_HTML_";
function GetGraph()
{
	var count;
_END_HTML_
	
	if (Util::IsBrowserMSIE($query)) {
		print "var form = document.all.statform;\n";
	}
	else {
		print "var form = document.statform;\n";
	}
		
	print << "_END_HTML_";
	/* we change the selection into text fields: */
	count = TransformList(form.data.options);
_END_HTML_

	#
	# Check sufficient parameters has been selected:
	#
	if ($gStatType eq "DATA") {
		print << "_END_HTML_";
		if (count == 0) {
			alert("Please select at least one Data (Response Time, CPU Load...)");
			return false;
		}
_END_HTML_
	}
	
	print "count = TransformList(form.servers.options);\n";

	if ($gStatType eq "SRV") {
		print << "_END_HTML_";
		if (count == 0) {
			alert("Please select at least one Server !");
			return false;
		}
_END_HTML_
	}
	
	print << "_END_HTML_";
	if (!form.avgval.checked && !form.minval.checked && !form.maxval.checked) {
		alert("Please select at least one statistics (Average, Min, Max)");
		return false;
	}
	
	return true;
}

-->
</script>
</head>

<body bgcolor="#FFFFFF" text="#000000">
	<table width=100% border=0>
		<tr>
			<td>
				<!-- HEADER -->
_END_HTML_

					if ($gStatType eq "DATA") {
						$gTitle = "MULTI-DATA STATISTICS";
						$gHelp  = "Select parameter values below,<br>then press the <Get Report> Button.<br><br>You can select MULTIPLE Indicators but ONE Server.";
					}
					elsif ($gStatType eq "SRV") {
						$gTitle = "MULTI-SERVER STATISTICS";
						$gHelp  = "Select parameter values below,<br>then press the <Get Report> Button.<br><br>You can select MULTIPLE Servers but ONE Indicator.";
					}
						
					require "panelheader.inc.pl"; 
					&OutputHeader($gTitle);

			print << "_END_HTML_";
			</td>
		</tr>
		<tr>
			<td>
				<table width=100% border=0>
					<tr>
						<td width="0%">
							<!-- LEFT MENU -->
_END_HTML_
							require "panelmenu.inc.pl"; 
							&OutputMenu();

						print << "_END_HTML_";
						</td>
						<td width="100%">
							<!-- MAIN BODY -->
							<form method="get" name="statform" action="statrt.pl" target="graph" onSubmit="JavaScript:return GetGraph();">
								<input type=hidden name=width value="$graphwidth">
								<input type=hidden name=height value="$graphheight">
								<table width=100% border=0>
									<tr>
										<td>
											<table width=100% border=0 cellspacing=0 cellpadding=0>
												<tr>
													<td width=15%>
														<!-- INSIDE MENU DISPLAY -->
_END_HTML_
														require "panelmenu2.inc.pl"; 
														&OutputMenu2($query,$gStatType,$layerheight,$graphwidth,$graphheight);
													
													print << "_END_HTML_";
													</td>
													<td width=3%>
														&nbsp;
													</td>
													<td width=82%>
														<!-- GRAPH DISPLAY -->
_END_HTML_
														do "panelgraph.inc.pl"; 
														&OutputGraph($query,$layerwidth,$layerheight,
															$graphwidth,$graphheight);
													print << "_END_HTML_";
													</td>
												</tr>
											</table>
											<br>
										</td>
									</tr>
									<tr>
										<td>
											<!-- PARAMS DISPLAY -->
_END_HTML_
											do "panelparam.inc.pl"; 
											&OutputParam($query,$gStatType,$db);

										print << "_END_HTML_";
										</td>
									</tr>
								</table>
							</form>
						</td>
					</tr>
				</table>
			</td>
		</tr>
	</table>
</body>
</html>
_END_HTML_

# EOF
