#!/usr/bin/perl -w
#
# ====================================================================
#
# Display the saved graph management window
#
# Date: 14 Aug 2003
# Author: Jerome Delamarche (c) Copyright INODES.  2003  All rights reserved.
# Version: 2.0
#
# Input Parameters:	
#		graph: #id (opt)
#		op: delete|view (opt) 
#
# Output: 		display the graph manager
#
# --------------------------------------------------------------------
#
# TODO:
#
# ====================================================================
#
use CGI qw/:standard/;
require "dbbenchmark.inc.pl";

my $query = new CGI;
my $gGraphID = undef;
my $gOp      = undef;
if (defined($query)) { 
	$gGraphID = $query->param('graph'); 
	$gOp = $query->param('op');
}

my $db = CDBBenchmark->new($Globals::dbtype,$Globals::dbname,
				$Globals::dbserver,$Globals::dbuser,$Globals::dbpwd);

print header;

# check if operation is required:
if (defined($gGraphID) && defined($gOp)) {
	if ($gOp eq "delete") {
		$db->GraphDelete($gGraphID);
	}
}

my $graphs = $db->GetGraphList();

print << "_END_HTML_";
<html>
<head>
	<title>Graph Management</title>
	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
	<link rel="stylesheet" type="text/css" href="../cpanel.css">
</head>

<body>
<script language="JavaScript">
<!--
function Confirm()
{
	return confirm("Do you really want to delete this Graph ?");
}

function ViewGraph(grid)
{
	var url = "viewgraph.pl?graph=" + grid;
	window.open(url,"Graph","width=400,height=300,resize=yes");
}
-->
</script>
<table bordercolor=#003399 width=100% cellspacing=0 cellpadding=1 border=1 nowrap>
	<tr height=14>
		<td width=17% align=center class=paramtitle>&nbsp;Date</td>
		<td width=63% class=paramtitle>&nbsp;Graph Name</td>
		<td width=10% class=paramtitle>&nbsp;View</td>
		<td width=10% class=paramtitleright>&nbsp;Delete</td>
	</tr>
_END_HTML_

for ( my $g = 0 ; $g < scalar(@{$graphs}) ; $g++ ) {
	print "<tr"; if ($g % 2) { print " bgcolor=#FFBB00"; } print ">\n";
		print "<td height=10 class=textstd>&nbsp;".substr($graphs->[$g]{"GRA_DATE"},0,11)."</td>\n";
		print "<td height=10 class=textstdblue>&nbsp;".$graphs->[$g]{"GRA_NAME"}."</td>\n";
		print "<td height=10 align=center><a href=\"\" onClick=\"JavaScript:ViewGraph(".$graphs->[$g]{"GRA_ID"}."); return false;\"><img src=\"../images/view.gif\" border=0></a></td>\n";
		print "<td height=10 align=center><a href=\"graphmgr.pl?op=delete&graph=".$graphs->[$g]{"GRA_ID"}."\" onClick=\"JavaScript: return Confirm();\"><img src=\"../images/delete.gif\" border=0></a></td>\n";
	print "</tr>\n";
}

print << "_END_HTML_";
</table>
</body>
</html>
_END_HTML_

1;

# EOF
