#!/usr/bin/perl -w
#
# ===========================================================================
#
# Message management:
#
# Date: 14 Aug 2003
# Author: Jerome Delamarche (c) Copyright INODES.  2003  All rights reserved.
# Version: 2.0
#
# ===========================================================================
#
package Messages;
$gLang = "en";

sub GetLanguage
{
	my ($query) = @_;

	if ($query->http("HTTP_ACCEPT_LANGUAGE") ne "") {
		return substr($query,"HTTP_ACCEPT_LANGUAGE",0,2);
	}
	
	return "en";	# default value
}

%gMsg = (
		"en" => {
				"Title"		=> "Benchmark Statistics Access",
				"LastUpdate"	=> "Last Update: ",
				"Display"	=> "Display",
				"Stat"		=> "Select one or more Indicators: ",
				"Stat_Apache"	=> "Apache Server Load",
				"Stat_CPU"	=> "CPU Load",
				"Stat_Time"	=> "Mean Response Time",
				"Stat_Mem"	=> "% Busy Memory",
				"Stat_Swap"	=> "% Busy Swap",
				"Stat_Alert"	=> "Alert Count",
				"Filter"	=> "Apply Filters:" ,
				"Graph"		=> "Select Graph Parameters: ",
				"Graph_Scale"	=> "Scale: ",
				"Graph_Type"	=> "Graph Type: ",
				"GS_Hour"	=> "Hour",
				"GS_Week"	=> "Week", 
				"GS_Month"	=> "Month",
				"GS_DayWeek"	=> "Day per Week",
				"GS_DayMonth"	=> "Day per Month",
				"GS_Last30d"	=> "Last 30 Days",
				"GT_BarGraph"	=> "Bar Graph",
				"GT_LinePoints"	=> "Line Points",
				"GT_AreaGraph"	=> "Area Graph",
				"GT_PieGraph"	=> "Pie Graph",
				"From"		=> "From: ",
				"To"		=> "To: ",
				"Request"	=> "Request: ",
				"All"		=> "All",
				"Threshold"	=> "Time Thresold: ",
				"TI_apache" 	=> "Apache Server Load",
				"YL_apache" 	=> "Count of busy instances",
				"LE_apache" 	=> "Apache",
				"TI_cpu"	=> "CPU Load",
				"YL_cpu"	=> "Percentage",
				"LE_cpu"	=> "CPU Load",
				"TI_mem"	=> "Used Memory",
				"YL_mem"	=> "Percentage",
				"LE_mem"	=> "Memory",
				"TI_swap"	=> "Used Swap",
				"YL_swap"	=> "Percentage",
				"LE_swap"	=> "Swap",
				"TI_time"	=> "Mean Response Time",
				"YL_time"	=> "Milli-sec",
				"LE_time"	=> "Time",
				"TI_alert"	=> "Generated Alerts",
				"YL_alert"	=> "Count",
				"LE_alert"	=> "Alerts",
				"TI_all"	=> "All Statistics",
				"YL_all"	=> "Value",
				"LE_all"	=> "All Statistics"
		}
);

%gShortMonth = (
		"en" => {
				"01" => "Jan",
				"02" => "Feb",
				"03" => "Mar",
				"04" => "Apr",
				"05" => "May",
				"06" => "Jun",
				"07" => "Jul",
				"08" => "Aug",
				"09" => "Sep",
				"10" => "Oct",
				"11" => "Nov",
				"12" => "Dec"
		},
);
	
sub ShortMonth
{
	my ($m) = @_;
	#global $gShortMonth,$gLang;
	
	return $gShortMonth{$gLang}{$m};
}

%gFullMonth = (
		"en" => {
				"01" => "January",
				"02" => "February",
				"03" => "March",
				"04" => "April",
				"05" => "May",
				"06" => "June",
				"07" => "July",
				"08" => "August",
				"09" => "September",
				"10" => "October",
				"11" => "November",
				"12" => "December"
		},
);

sub FullMonth
{
	my ($m) = @_;
	#global $gFullMonth,$gLang;
	
	return $gFullMonth{$gLang}{$m};
}

%gDay = (
		"en" => [
				"Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"
		],
);

%gShortDay = (
		"en" => [
				"Sun","Mon","Tue","Wed","Thu","Fri","Sat"
		],
);

sub GetDay
{
	my ($idx) = @_;
	#global $gDay,$gLang;

	return $gDay{$gLang}{$idx};
}

sub BenchGetText
{
	my ($id) = @_;
	#global $gLang,$gMsg;
	
	return $gMsg{$gLang}{$id};
}

1;

# EOF
