#!/usr/bin/perl -w
use strict;
#
# ====================================================================
#
# Save a graph in the DB
#
# Date: 14 Aug 2003
# Author: Jerome Delamarche (c) Copyright INODES.  2003  All rights reserved.
# Version: 2.0
#
# Input Parameters:	
#		graph
#		width, height
#		name
#		note
#
# Output: indicates whether or not the graph could be saved
#
# --------------------------------------------------------------------
#
# TODO: 
#
# ====================================================================
#
use CGI qw/:standard/;
use File::Basename;

require "dbbenchmark.inc.pl";

my $query = new CGI;

my $gNote 	= $query->param("note");
my $gGraph	= $query->param("graph");
my $gWidth     	= $query->param("width");
my $gHeight    	= $query->param("height");
my $gName 	= $query->param("name");

my $gReferer	= "saveform.pl?name=$gName&note=$gNote&graph=$gGraph&width=$gWidth&height=$gHeight";

my $gCurDir	= dirname($ENV{'SCRIPT_FILENAME'});

# Read the SVG file at once, as a big string:
open(FD,"< $gCurDir/$gGraph");
undef $/;
my $graphContent = <FD>;
close(FD);
$graphContent =~ s/\n//g;

my $db = CDBBenchmark->new($Globals::dbtype,$Globals::dbname,
				$Globals::dbserver,$Globals::dbuser,$Globals::dbpwd);

print header;

my $result = $db->StoreGraph($gName,$gNote,$graphContent,$gWidth,$gHeight);
if ($result == 0) {

my $err = $db->LastError();

print << "_END_HTML_";
<html>
<head>
	<title>Save Error</title>
	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
	<link rel="stylesheet" type="text/css" href="../cpanel.css">
</head>

<body>
<table width=100% cellspacing=0 cellpadding=3 border=0>
<tr>
<td width=60 valign=top><img src="$Globals::gLeftLogo" border=0 height=300></td>
<td>
	<p align=center class=textscale>
		Graph could not be saved !
	</p>
	<p align=center class=text12>
		Error message is:<br><span class=text12b>$err</span>
	</p>
	<p align=center class=textscale>
		Click <a href="$gReferer">here</a> to go back
	</p>
</td>
</tr>
</table>
</body>
</html>
_END_HTML_
	die;
}

print << "_END_HTML_";
<html>
<head>
	<title>Graph Saved</title>
	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
	<link rel="stylesheet" type="text/css" href="../cpanel.css">
	<script language="JavaScript">
	<!--
	function CloseWin() 
	{
		window.close();
	}
	-->
	</script>
</head>

<body onLoad="JavaScript:setTimeout(CloseWin,$Globals::gPopupTimeout);">
<table width=100% cellspacing=0 cellpadding=3 border=0>
<tr>
<td width=60 valign=top><img src="$Globals::gLeftLogo" border=0 height=300></td>
<td>
	<p align=center class=textscale>
		Graph successfully saved !
	</p>
	<br>
	<p align=center class=textstd>
		This window will automatically close in few seconds.
	</p>
</td>
</tr>
</table>
</body>
</html>
_END_HTML_

# EOF
