#!/usr/bin/perl -w
use strict;
#
# ====================================================================
#
# Send a result to the specified email address
#
# Date: 14 Aug 2003
# Author: Jerome Delamarche (c) Copyright INODES.  2003  All rights reserved.
# Version: 2.0
#
# Input Parameters:	
#		to
#		from
#		subject
#		body
#		graph
#
# Output: indicates whether or not the mail could be sent
#
# --------------------------------------------------------------------
#
# TODO:
#
# ====================================================================
#
use CGI qw/:standard/;
use File::Basename;

require "util.inc.pl";

my $query = new CGI;

my $gTo 	= $query->param("to");
my $gFrom	= $query->param("from");
my $gSubject 	= $query->param("subject");
my $gBody 	= $query->param("body");
my $gGraph	= $query->param("graph");
my $gCurDir	= dirname($ENV{'SCRIPT_FILENAME'});

my $gReferer	= "sendform.pl?to=$gTo&from=$gFrom&subject=$gSubject&body=$gBody&graph=$gGraph";

require "email_message.inc.pl";

my $email_message = EmailMessage->new();
$email_message->SetEncodedEmailHeader("To",$gTo,$gTo);
$email_message->SetEncodedEmailHeader("From",$gFrom,$gFrom);
$email_message->SetEncodedEmailHeader("Reply-To",$gFrom,$gFrom);

#if(defined("PHP_OS") && strcmp(substr(PHP_OS,0,3),"WIN"))
#	$email_message->SetHeader("Return-Path",$gFrom);
	
$email_message->SetEncodedEmailHeader("Errors-To",$gFrom,$gFrom);
$email_message->SetEncodedHeader("Subject",$gSubject);
#$email_message->AddQuotedPrintableTextPart($email_message->WrapText($message));
$email_message->AddQuotedPrintableTextPart($gBody);

my %graph = ("FileName" => "$gCurDir/$gGraph" , "Content-Type" => "image/svg");
my $graph_part;

# embedded:
$email_message->CreateFilePart(\%graph,\$graph_part);
my @parts = ($graph_part);
$email_message->AddMixedMultipart(\@parts);

my $error = $email_message->Send();
if (defined($error) && $error ne "") {

	print << "_END_HTML_";
<html>
<head>
	<title>Send Error</title>
	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
	<link rel="stylesheet" type="text/css" href="../cpanel.css">
</head>

<body>
<table width=100% cellspacing=0 cellpadding=3 border=0>
<tr>
<td width=60 valign=top><img src="$Globals::gLeftLogo" border=0 height=300></td>
<td>
	<p align=center class=textscale>
		Mail could not be sent to $gTo
	</p>
	<p align=center class=text12>
		Error message is:<br><span class=text12b>$error</span>
	</p>
	<p align=center class=textscale>
		Click <a href="$gReferer">here</a> to go back
	</p>
</td>
</tr>
</table>
</body>
</html>
_END_HTML_
}
else {
	print << "_END_HTML_";
<html>
<head>
	<title>Results Sent</title>
	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
	<link rel="stylesheet" type="text/css" href="../cpanel.css">
	<script language="JavaScript">
	<!--
	function CloseWin() 
	{
		window.close();
	}
	-->
	</script>
</head>

<body onLoad="JavaScript:setTimeout(CloseWin,$Globals::gPopupTimeout);">
<table width=100% cellspacing=0 cellpadding=3 border=0>
<tr>
<td width=60 valign=top><img src="$Globals::gLeftLogo" border=0 height=300></td>
<td>
	<p align=center class=textscale>
		A mail has been successfully sent to $gTo
	</p>
	<br>
	<p align=center class=textstd>
		This window will automatically close in few seconds.
	</p>
</td>
</tr>
</table>
</body>
</html>
_END_HTML_
}

# EOF
