#!/usr/bin/perl -w
use strict;
#
# ====================================================================
#
# Send a result to the specified email address
#
# Date: 14 Aug 2003
# Author: Jerome Delamarche (c) Copyright INODES.  2003  All rights reserved.
# Version: 2.0
#
# Input Parameters:	
#		to
#		from
#		subject
#		body
#		graph
#
# Output: indicates whether or not the mail could be sent
#
# --------------------------------------------------------------------
#
# TODO:
#
# ====================================================================
#
use CGI qw/:standard/;
use File::Basename;

require "util.inc.pl";

my $query = new CGI;

my $gTo 	= $query->param("to");
my $gFrom	= $query->param("from");
my $gSubject 	= $query->param("subject");
my $gBody 	= $query->param("body");
my $gGraph	= $query->param("graph");
my $gCurDir	= dirname($ENV{'SCRIPT_FILENAME'});

my $gReferer	= "sendform.pl?to=$gTo&from=$gFrom&subject=$gSubject&body=$gBody&graph=$gGraph";

use Mail::Sender;

my $email_message = new Mail::Sender {
	"from" 		=> $gFrom,
	"to"   		=> $gTo,
	"replyto"	=> $gFrom,
	"subject"	=> $gSubject,
};

#$email_message->SetEncodedEmailHeader("Errors-To",$gFrom,$gFrom);

if (ref $email_message->OpenMultipart({
		'smtp' => "localhost",
		'boundary' => "dummy-boundary-9999999",
		'multipart' => "related"})) {
	$email_message->Body({
		'ctype' => "text/html",
		'charset' => "charset=iso-8859-1",
		'encoding' => "8bit",
		'msg' => $gBody,
	});
	$email_message->Attach({
		'description' => "image",
		'ctype' => "image/svg",
		'encoding' => "base64",
		'disposition' => "NONE",
		'file' => "$gCurDir/$gGraph",
	});
}

print header;

if ($Mail::Sender::Error ne "") {
	print << "_END_HTML_";
<html>
<head>
	<title>Send Error</title>
	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
	<link rel="stylesheet" type="text/css" href="../cpanel.css">
</head>

<body>
<table width=100% cellspacing=0 cellpadding=3 border=0>
<tr>
<td width=60 valign=top><img src="$Globals::gLeftLogo" border=0 height=300></td>
<td>
	<p align=center class=textscale>
		Mail could not be sent to $gTo
	</p>
	<p align=center class=text12>
		Error message is:<br><span class=text12b>$Mail::Sender::Error</span>
	</p>
	<p align=center class=textscale>
		Click <a href="$gReferer">here</a> to go back
	</p>
</td>
</tr>
</table>
</body>
</html>
_END_HTML_
}
else {
	print << "_END_HTML_";
<html>
<head>
	<title>Results Sent</title>
	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
	<link rel="stylesheet" type="text/css" href="../cpanel.css">
	<script language="JavaScript">
	<!--
	function CloseWin() 
	{
		window.close();
	}
	-->
	</script>
</head>

<body onLoad="JavaScript:setTimeout(CloseWin,$Globals::gPopupTimeout);">
<table width=100% cellspacing=0 cellpadding=3 border=0>
<tr>
<td width=60 valign=top><img src="$Globals::gLeftLogo" border=0 height=300></td>
<td>
	<p align=center class=textscale>
		A mail has been successfully sent to $gTo
	</p>
	<br>
	<p align=center class=textstd>
		This window will automatically close in few seconds.
	</p>
</td>
</tr>
</table>
</body>
</html>
_END_HTML_
}

# EOF
