#!/usr/bin/perl -w
use strict;
#
# ====================================================================
#
# Display a graph
#
# Date: 14 Aug 2003
# Author: Jerome Delamarche (c) Copyright INODES.  2003  All rights reserved.
# Version: 2.0
#
# Input Parameters:	
#		graph
#
# Output: 		display the graph manager
#
# --------------------------------------------------------------------
#
# TODO:
#
# ====================================================================
#
use File::Basename;
use CGI qw/:standard/;
require "dbbenchmark.inc.pl";

my $query = new CGI;
my $gGraphID = $query->param("graph");

my $db = CDBBenchmark->new($Globals::dbtype,$Globals::dbname,
				$Globals::dbserver,$Globals::dbuser,$Globals::dbpwd);

my $onLoad;
my $agraph;
my %imgname;
my $w;
my $h;

print header;

# check if operation is required:
if (!defined($gGraphID)) {
	$onLoad = "No Graph specified !";
}
else {
	$agraph = $db->GraphGet($gGraphID);
	if (!defined($agraph) || $agraph == 0) {
		# an error occurred !
		$onLoad = "JavaScript: alert('Requested Graph could not be found in Database !');";
	}
	else {
		# compute a temporary filename:
		my $curdir = dirname($ENV{'SCRIPT_FILENAME'});
		($imgname{"local"},$imgname{"remote"}) = &Util::GetImageName($curdir,"svg");
		open(FD,"> ".$imgname{"local"});
		print FD $agraph->{'GRA_BLOB'};
		close(FD);

		$w = $agraph->{"GRA_WIDTH"} + 90;
		$h = $agraph->{"GRA_HEIGHT"} + 130;
		$onLoad = "JavaScript: window.resizeTo($w,$h);";
	}
}

print << "_END_HTML_";
<html>
<head>
	<title>View a Graph</title>
	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
	<link rel="stylesheet" type="text/css" href="../cpanel.css">
</head>

<body onLoad="$onLoad">
<table width=100% cellspacing=0 cellpadding=3 border=0>
<tr>
<td bgcolor="$Globals::gLeftLogoBgColor" width=60 valign=top><img src="$Globals::gLeftLogo" border=0 height=300></td>
<td>
	<table width=100%>
		<tr>
			<td colspan=2 align=center valign=top class=paramtitle>$agraph->{"GRA_NAME"}</td>
		</tr>
		<tr>
			<td width=20% class=text10b align=right>Creation Date:</td>
			<td width=80% class=textstd>$agraph->{"GRA_DATE"}</td>
		</tr>
		<tr>
			<td class=text10b align=right>Note:</td>
			<td class=textstd valign=top><textarea rows=2 class=inputtext2 cols=60>$agraph->{"GRA_NOTE"}</textarea></td>
		</tr>
		<tr>
			<td colspan=2>
				<embed name=graph type="image/svg" 
					pluginspage="http://www.adobe.com/svg/viewer/install/"
					src="$imgname{"remote"}"
					width="$agraph->{"GRA_WIDTH"}"
					height="$agraph->{"GRA_HEIGHT"}">
				</embed>
			</td>
		</tr>
	</table>
</td>
</tr>
</table>
</body>
</html>
_END_HTML_

# EOF
