#!/usr/bin/perl -w
use strict;
# ===========================================================
#
# Short script that display the graph in a popup window.
# Called by "zomm" button
#
# Date: 14 Aug 2003
# Author: Jerome Delamarche (c) Copyright INODES.  2003  All rights reserved.
# Version: 2.0
#
# -----------------------------------------------------------
#
# Input:
#		img: URI of graph to display
#		factor: zoom factor
#		width, height: normal sizes
#
# ===========================================================
use File::Basename;
use CGI qw/:standard/;
require "util.inc.pl";

my $query = new CGI;
my $gImg	= $query->param("img");
my $gWidth	= $query->param("width");
my $gHeight	= $query->param("height");
my $gFactor 	= $query->param("factor");

if (!defined($gFactor)) { $gFactor = 2; }

print header;

# Create a new file from the original and apply the zoom factor:
my $curdir   = dirname($ENV{"SCRIPT_FILENAME"});
my %gImgName;
($gImgName{'local'},$gImgName{'remote'}) = &Util::GetImageName($curdir,"svg");

open(FIN,"< $curdir/$gImg");
my @lines = <FIN>;
close(FIN);

open(FOU,"> ".$gImgName{'local'});
my $l;
for ( $l = 0 ; $l < scalar(@lines) ; $l++ ) {
	print FOU $lines[$l];
	if ($l == 3) {
		print FOU "<g transform='scale($gFactor,$gFactor)'>\n";
	}
	elsif ($l == scalar(@lines) - 3) {
		print FOU "</g>\n";
	}
}
close(FOU);

# Parameters for "startoutput.inc.pl":
my $gDuration = "any";
my $gViewType = "graph";
my $gImgType  = "svg";
my $gGraphWidth = $gWidth * $gFactor;
my $gGraphHeight = $gHeight * $gFactor;
my $gTableOutput = "";
my $gNavigationBar = "";

# UGLY: the following code it the same as the one in the SendHTML() function in statrt.pl
print << "_END_HTML_";
<html>
<head>
	<title>Graph</title>
	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
	<link rel="stylesheet" type="text/css" href="../cpanel.css">
</head>

<body>
	<div align=center>
		<table width=100%>
			<tr>
				<td align=center>
_END_HTML_
			if (!defined($gDuration) or $gDuration eq "") {
				print "<img name=graph src=\"".$gImgName{'remote'}."\">\n";
			}
			if (defined($gViewType) and $gViewType eq "graph") { 
				if (defined($gImgType) and $gImgType eq "svg") {
					print "<embed name=graph type=\"image/svg\" ".
							"pluginspage=\"http://www.adobe.com/svg/viewer/install/\" ".
							"src=\"".$gImgName{"remote"}.
							"\" width=".$gGraphWidth.
							" height=".$gGraphHeight."></embed>\n";
				}
			}
			else {
				# view type is a table:
				print $gTableOutput."\n";
			}
print << "_END_HTML_";
				</td>
			</tr>
_END_HTML_
			if ($gNavigationBar ne "") {
print << "_END_HTML_";
			<tr>
				<td width=100% align=center>
					<span class=textstdblue>$gNavigationBar</span>
				</td>
			</tr>
_END_HTML_
			}
print << "_END_HTML_";
		</table>
	</div>
</body>					
</html>
_END_HTML_

# EOF
