<?php
#
# ====================================================================
#
# Main control panel
#
# Date: 14 Aug 2003
# Author: Jerome Delamarche (c) Copyright INODES.  2003  All rights reserved.
# Version: 2.0
#
# Input Parameters:	
#			stattype
#
# Output: 		display the control panel
#
# --------------------------------------------------------------------
#
# TODO:
#
# ====================================================================
#
include_once "dbbenchmark.inc.php";
include_once "globals.inc.php";
include_once "util.inc.php";

$gStatType = SetParmValue("stattype");
if (empty($gStatType)) $gStatType = "DATA";

$db = new CDBBenchmark($dbtype,$dbname,$dbserver,$dbuser,$dbpwd);
$layerwidth  = 540;
$layerheight = 250;
$graphwidth  = $layerwidth - 60;
$graphheight = $layerheight - 40;
?>
<html>
<head>
	<title>Statistics Main Page</title>
	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
	<link rel="stylesheet" type="text/css" href="../cpanel.css">
</head>

<script language="JavaScript">
<!--
function TransformList(opt)
{
	var count = 0;
	
	<?php
	if (IsBrowserMSIE()) {
	?>
		for ( var i = 0 ; i < opt.length ; i++ ) {
			if (opt[i].selected) {
				count++;
				eval('document.all.statform.' + opt[i].value + '.value = "yes";');
			}
			else	
				eval('document.all.statform.' + opt[i].value + '.value = "";');
		}
	<?php 
	}
	else {
	?>
		for ( var i = 0 ; i < opt.length ; i++ ) {
			if (opt[i].selected) {
				eval('document.statform.' + opt[i].value + '.value = "yes";');
				count++;
			}
			else	
				eval('document.statform.' + opt[i].value + '.value = "";');
		}
	<?php
	}
	?>
	
	return count;
}

function GetGraph()
{
	var count;
	
	<?php
	if (IsBrowserMSIE()) {
	?>
		var form = document.all.statform;
	<?php 
	}
	else {
	?>
		var form = document.statform;
	<?php
	}
	?>
		
	/* Because PHP does not handle multiple selection in <SELECT>
	 * correctly, we change the selection into text fields:
	 */
	count = TransformList(form.data.options);

	/*
	 * Check sufficient parameters has been selected:
	 */
	<?php
	if ($gStatType == "DATA") {
	?>
		if (count == 0) {
			alert("Please select at least one Data (Response Time, CPU Load...)");
			return false;
		}
	<?php
	}
	?>
	
	count = TransformList(form.servers.options);

	<?php
	if ($gStatType == "SRV") {
	?>
		if (count == 0) {
			alert("Please select at least one Server !");
			return false;
		}
	<?php
	}
	?>
	
	if (!form.avgval.checked && !form.minval.checked && !form.maxval.checked) {
		alert("Please select at least one statistics (Average, Min, Max)");
		return false;
	}	
	
	return true;
}

-->
</script>

<body bgcolor="#FFFFFF" text="#000000">
	<table width=100% border=0>
		<tr>
			<td>
				<!-- HEADER -->
				<?php 
					if ($gStatType == "DATA") {
						$gTitle = "MULTI-DATA STATISTICS";
						$gHelp  = "Select parameter values below,<br>then press the <Get Report> Button.<br><br>".
									"You can select MULTIPLE Indicators but ONE Server.";
					}
					else if ($gStatType == "SRV") {
						$gTitle = "MULTI-SERVER STATISTICS";
						$gHelp  = "Select parameter values below,<br>then press the <Get Report> Button.<br><br>".
									"You can select MULTIPLE Servers but ONE Indicator.";
					}
						
					include "panelheader.inc.php"; 
				?>
			</td>
		</tr>
		<tr>
			<td>
				<table width=100% border=0>
					<tr>
						<td width="0%">
							<!-- LEFT MENU -->
							<?php include "panelmenu.inc.php"; ?>
						</td>
						<td width=100%>
							<!-- MAIN BODY -->
							<form method="get" name="statform" action="statrt.php" target="graph" onSubmit="JavaScript:return GetGraph();">
								<input type=hidden name=width value=<?php echo $graphwidth ?>>
								<input type=hidden name=height value=<?php echo $graphheight ?>>
								<table width=100% border=0>
									<tr>
										<td>
											<table width=100% border=0 cellspacing=0 cellpadding=0>
												<tr>
													<td width=15%>
														<!-- INSIDE MENU DISPLAY -->
														<?php include "panelmenu2.inc.php"; ?>
													</td>
													<td width=3%>
														&nbsp;
													</td>
													<td width=82%>
														<!-- GRAPH DISPLAY -->
														<?php include "panelgraph.inc.php"; ?>
													</td>
												</tr>
											</table>
											<br>
										</td>
									</tr>
									<tr>
										<td>
											<!-- PARAMS DISPLAY -->
											<?php include "panelparam.inc.php"; ?>
										</td>
									</tr>
								</table>
							</form>
						</td>
					</tr>
				</table>
			</td>
		</tr>
	</table>
</body>
</html>
