<?php
# ====================================================================
#
# Script used to generate test values in Benhcmark Database:
#
# Date: 14 Aug 2003
# Author: Jerome Delamarche (c) Copyright INODES.  2003  All rights reserved.
# Version: 2.0
#
# ====================================================================

include_once "messages.inc.php";
include_once "dbbenchmark.inc.php";
include_once "globals.inc.php";

$db = new CDBBenchmark($dbtype,$dbname,$dbserver,$dbuser,$dbpwd);

# --------------------------------------
# Generate logs in t_benchmark_log table:
# --------------------------------------

# URLs are taken from the following array:
$gURL = Array(
			"/index.htm",
			"/dir1/file1.html",
			"/dir1/file2.php",
			"/dir2/file1.gif",
			"/images/logo.gif",
			"/images/logo2.gif",
			"/images/ads/php.jpg",
			"/images/ads/zend.com.png",
			"/longdir/withverylongname/tomakesure-wetruncatewhennecessary/therealnameofthe/finalfile.html",
		);

# Servers are taken from the followin array:
$gServer = Array(
			"127.0.0.1","192.168.1.1","192.168.1.2","192.168.1.3",
		);
		
# Protocols are taken from the followin array:
$gProtocol = Array(
			"80","443","8080","110","8000",
		);
		
# Date are computed from the two following range:
$gStartDate = "2002-01-01 00:00:00";
$gEndDate   = "2004-12-31 23:59:59";

# Response time is taken between the 2 following values:
$gMinTime   = 5;
$gMaxTime   = 5000;

# Alerts are generated when the following threshold is reached:
$gThreshold = 1000;

# How many logs do we generate ?
$gLogCount  = 10000;

# Other values (system load, memory use...) are taken in range 1 to 100.

# Let's generate the logs:
$p = split("[-: ]",$gStartDate);
$stime = mktime($p[3],$p[4],$p[5],$p[1],$p[2],$p[0]);
$p = split("[-: ]",$gEndDate);
$etime = mktime($p[3],$p[4],$p[5],$p[1],$p[2],$p[0]);
//echo "$stime $etime ".time()."\n";
srand ((double) microtime() * 1000000);

for ( $idx = 1 ; $idx <= $gLogCount ; $idx++ ) {
	$log_date = strftime("%Y-%m-%d %H:%M:%S",rand($stime,$etime));
	
	$url_value = $gURL[rand(0,count($gURL)-1)];
	//$arg_value = ;
	//$fil_value = ;
	//$log_status = ;
	$t = rand($gMinTime,$gMaxTime);
	$ben_sec = floor($t / 1000);
	$ben_usec = ($t % 1000) * 1000;
	$ben_ready = rand(0,100);
	$ben_busy = rand(0,100);
	$ben_pzombie = rand(0,100);
	$ben_prunning = rand(0,100);
	$ben_pstopped = rand(0,100);
	$ben_psleeping = rand(0,100);
	$ben_avgload = rand(1,100);
	$ben_memuse = rand(1,100);
	$ben_swapuse = rand(1,100);
	//$ben_cliaddr = ;
	$ben_srvaddr = ip2long($gServer[rand(0,count($gServer)-1)]);
	$ben_srvport = $gProtocol[rand(0,count($gProtocol)-1)];
	
	$query = "INSERT INTO T_BENCHMARK_LOG (LOG_DATE,URL_VALUE,BEN_SEC,BEN_USEC,BEN_READY,".
					"BEN_PZOMBIE,BEN_BUSY,BEN_PRUNNING,BEN_PSTOPPED,BEN_PSLEEPING,BEN_AVGLOAD,BEN_MEMUSE,BEN_SWAPUSE,".
					"BEN_SRVADDR,BEN_SRVPORT) VALUES (\"$log_date\",\"$url_value\",$ben_sec,$ben_usec,$ben_ready,".
					"$ben_pzombie,$ben_busy,$ben_prunning,$ben_pstopped,$ben_psleeping,$ben_avgload,".
					"$ben_memuse,$ben_swapuse,$ben_srvaddr,$ben_srvport)";
	$db->m_int->QueryExecute($query);
	echo "ok\n";
	
	if ($threshold > $gThreshold) {
		$query = "INSERT INTO T_BENCHMARK_ALERT (LOG_DATE,URL_VALUE) VALUES (\"$log_date\",\"$url_value\")";
		$db->m_int->QueryExecute($query);
	}
}
?>
