<?php
#
# ====================================================================
#
# Small utility functions
#
# Date: 14 Aug 2003
# Author: Jerome Delamarche (c) Copyright INODES.  2003  All rights reserved.
# Version: 2.0
#
# --------------------------------------------------------------------
#
# TODO:
#
# ====================================================================
#
include_once "globals.inc.php";

# 
# Utility functions:
#

// Test the browser type:
function IsBrowserMSIE()
{
	$agent = $HTTP_SERVER_VARS["HTTP_USER_AGENT"];
	if (empty($agent))
		$agent = $_SERVER["HTTP_USER_AGENT"];
		
	return strstr($agent,"MSIE");
}

# -----------------------------------
# Handle compatibility before PHP 4.2:
# -----------------------------------
function SetParmValue($parm)
{
	if (gettype($_REQUEST) != "array") {
		return $GLOBALS[$parm];
	}

	return $_REQUEST[$parm];
}

#
# ----------------------------------
# Generate the unique image filename:
# ----------------------------------
#
function GetImageName($suffix)
{
	global $HTTP_SERVER_VARS;
	
	$curdir	= dirname($HTTP_SERVER_VARS["SCRIPT_FILENAME"]);
	if (empty($curdir))
		$curdir = dirname($GLOBALS["SCRIPT_FILENAME"]);

	// Loop on the file existence added on the 30 July 2003
	$idx = 0;
	while ($idx++ < 10000) {
		srand((double)microtime() * 1000000);
		$prefix = rand();
		$imgname["local"] = "$curdir/../stats/$prefix.$suffix";
		$imgname["remote"] = "../stats/$prefix.$suffix";

		if (!file_exists($imgname["local"])) break;
	}

	return $imgname;
}

# -------------------------------
# Remove files older than max age:
# -------------------------------
function CleanReports($maxage)
{
	// $maxage is a count of hours:
	global $HTTP_SERVER_VARS;
	$curdir	= dirname($HTTP_SERVER_VARS["SCRIPT_FILENAME"]);
	if (empty($curdir))
		$curdir = dirname($GLOBALS["SCRIPT_FILENAME"]);

	$curtime = time();
	
	$fd = @opendir("$curdir/../stats");
	if (!$fd) return;
	
	while (($file = @readdir($fd)) !== false) {
		if ($file == "." || $file == "..")
			continue;
			
		$info = @stat("$curdir/../stats/$file");
		if (!$info)
			continue;
		
		if ($curtime > $info[10] + $maxage * 3600) {
			@unlink("$curdir/../stats/$file");
		}
	}
	@closedir($fd);
}

// Simple log function...
function ErrorLog($text)
{
	syslog(3,$text);
}

// translate a TIMESTAMP into a DATETIME:
function DateUnixToDB($d) {
	return date("Y-m-d H:i:00",$d);
}

// Translate a DATETIME into a TIMESTAMP:
function DateDBToUnix($d) {
	return mktime(	$d[11]*10+$d[12],
			$d[14]*10+$d[15],
			$d[17]*10+$d[18],
			$d[5]*10+$d[6],
			$d[8]*10+$d[9],
			$d[0]*1000+$d[1]*100+$d[2]*10+$d[3]);
}

// Remove the "dangerous character" from a string before 
// an INSERT or an UPDATE SQL stmt:
function SQLMakeStringSafe($s) 
{
	return ereg_replace("[|\\\"']","",$s);
}

// Remove the "dangerous character" from an integer before 
// an INSERT or an UPDATE SQL stmt:
function SQLMakeIntSafe($s)
{
	return ereg_replace("[^0-9]","",$s);
}

?>
